[![Kodi version](https://img.shields.io/badge/kodi%20versions-19+-blue)](https://kodi.tv/)
[![GitHub release](https://img.shields.io/github/v/release/cmik/plugin.video.tfctv.svg)](https://github.com/cmik/plugin.video.tfctv/releases)

## TFC.tv add-on
Watch your favorite online Pinoy shows, movies, news and live channels directly from your TV with the TFC.tv add-on for Kodi! This add-on works with your TFC.tv account and TFC.tv website. Media contents are all properties of TFC Online and is for personal private and domestic use only. 
**This is not an official TFC.tv add-on nor released by TFC / ABS-CBN.**


**REPO:**
You can find my repo here where you can install TFC.tv add-on: 
SHORT LINK: https://cmik.me/repozip

**ADD-ON VERSIONS:**
The link to different versions of TFC.tv add-on since 0.44:
SHORT LINK: https://cmik.me/dDfuhJMwAt

**LATEST VERSION:** 
The latest working version can be found here : https://cmik.me/tfctvlastzip 

**SOURCE CODE:**
The source code is published on Github.
Find the source code here: https://cmik.me/tfctvSourceCode 

Do not hesitate to share your feedbacks (ideas for new features, bug issues, etc...) about this add-on so we can improve it together.

You can find some help from other users througth TFC.tv Kodi Forum thread [Release - [CMIK] TFC.tv addon - repo / updates / support](https://forum.kodi.tv/showthread.php?tid=317008) - https://forum.kodi.tv/showthread.php?tid=317008

---
## Q&A

### How do I install one of Cmik's add-on?
Add the following source in your File Manager : https://repo.cmik.me  (ex: name it "cmik.repo")
>- Go to System > add-ons > install from zip
>- Select the new source cmik.repo / [add-on] and select the latest version zip file
>- Reboot your Kodi system to apply changes to the associated service (proxy and library checker)

Or 

Simply download and install the repo from https://cmik.me/repozip
>- Install the zip on your device
>- Go to System > add-ons > install from zip and search for the Zip
>- Then opened Kodi > System > Add-ons > Install from repository> Cmik repo > \[add-on\]

See also:
>[How to install from zip file](http://kodi.wiki/view/HOW-TO:Install%20add-ons%20from%20zip%20files)
>[How to install add-ons](http://kodi.wiki/view/HOW-TO:Install%20add-ons)

For Firestick users:
>- Use the Downloader app from the amazon appstore to download the zip to the Firestick.
>- Open kodi > system > add-ons > install from zip > external > downloader > Cmik repo
>- install from repository> Cmik repo > \[add-on\]


### How to update to the latest version?
Normally, Kodi checks for updates at startup or from time to time.
You can also force Kodi to check for updates:

Go to general "Settings" > Add-on > "Seach for updates" (mine is in menu sidebar).

See also:
>[How_to_access_the_Add-on_manager (wiki)](http://kodi.wiki/view/Add-on_manager#How_to_access_the_Add-on_manager)
>[How to update your add-on (wiki)](http://kodi.wiki/view/Add-on_manager#Updating)


### I can't play a movie, episode or a live stream
>- Check your internet connection
>- Check that you have enabled the Streaming Proxy in the add-on advanced settings (reboot Kodi after any modification)
>- If you have a message "The streaming proxy is not active...". Please reboot your Kodi system.
>- A notification message will normally appear when you play this type of content.


### How can I export my TFC.tv shows in my Kodi library (export .strm and .nfo files)
>1. In the add-on general settings > Export to Library > set enable context menu to ON.
>2. Choose your personnal export path or leave it blank (it will export in the addon userdata folder by default)
>3. Set the number of last episodes to check & export (8 last episodes by default).
>4. Set the Automatic update to ON.
>5. Reboot your Kodi
>6. You can now export a show from the context menu when you are on a show list.
>7. Exit the add-on and go to Videos > Add videos... > select your "library" folder or by default the Kodi userdata directory (ex: ".../userdata/addon_data/plugin.video.tfctv/library").
[Click here](https://kodi.wiki/view/Userdata) to know the userdata directory path according to your operating system.
>7. The add-on will only export .strm and .nfo files but you will have to execute a new content check for Kodi to add new contents to its library. You can also install the add-on "Library Auto Updater" from the Kodi repository to schedule an automatic update.


### You've found a bug. How can I report it?
If you encounter anything that you think is a bug, please report it to the add-on github repo (https://github.com/cmik/plugin.video.tfctv/issues). 
Do not hesitate to give more details about your issue: 
>- your device & plateform version
>- your add-on version
>- how to reproduce the bug or the error
>- the corresponding error message in Kodi.log file (beforehand, enable Debug mode on the add-on advanced settings and set debug level at least to INFO)
>- the URL link to your kodi.log pasted file

To simply export and share your log file, I recommend you to use the Kodi Logfile Uploader add-on (https://kodi.wiki/view/Add-on:Kodi_Logfile_Uploader)).



Find more info at https://addons.cmik.me

Enjoy!

---

If you like my work, you can support me by making a donation:
- [Donate with Paypal](https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=Q8DETSCYJDR7E&currency_code=EUR&source=url)
![Donate with Paypal](https://www.cmik.me/img/donate_paypal.png)
